﻿namespace UltraTimeLineWithCheckBoxes
{
    using System;
    using System.Drawing;
    using System.Windows.Forms;
    using System.Collections.Generic;

    using Infragistics.Win.UltraWinSchedule;

    public partial class Form1 : Form
    {
        private Dictionary<Owner, Dictionary<DateTime, bool>> initialData = new Dictionary<Owner,Dictionary<DateTime,bool>>();

        public Form1()
        {
            this.InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraCalendarInfo1.SelectedDateRanges.Add(DateTime.Now, DateTime.Now.AddDays(1));
            this.ultraDayView1.CreationFilter = new MyCreation(initialData);

            Point checkBoxLocation = new Point(5, 2);

            for (int i = 0; i < 10; i++)
            {
                Owner owner = ultraCalendarInfo1.Owners.Add(string.Format("Owner {0}", i));
                CheckBox checkBox = new CheckBox();
                checkBox.Name = owner.Key;
                checkBox.Text = string.Format("Show {0}", owner.Key);
                checkBox.Location = checkBoxLocation;
                checkBoxLocation.Offset(0, 23);
                this.panel1.Controls.Add(checkBox);
                Binding binding = checkBox.DataBindings.Add("Checked", owner, "Visible");
                binding.DataSourceUpdateMode = DataSourceUpdateMode.OnPropertyChanged;
                binding.ControlUpdateMode = ControlUpdateMode.OnPropertyChanged;

                // Set check state of all CheckBoxes with today date to checked
                Dictionary<DateTime, bool> checkedState = new Dictionary<DateTime, bool>();
                checkedState[DateTime.Today] = true;
                initialData.Add(owner, checkedState);
            }

            this.ultraDayView1.PreferredInViewColumnCount = 3;

            this.ultraCalendarInfo1.Owners["{unassigned_owner}"].Visible = false;
            ((MyCreation)ultraDayView1.CreationFilter).DayHeaderCheck += this.Form1_DayHeaderCheck;

            ultraDayView1.DrawFilter = new MyDraw();
        }

        private void Form1_DayHeaderCheck(object sender, DayHeaderCheckBoxArg e)
        {
            CheckBox cb = sender as CheckBox;
            if (cb != null)
            {
                MessageBox.Show(string.Format("Checkbox for {0} on {1} clicked {2}", e.Owner.Key, e.Date.ToShortDateString(), cb.Name));

            }
        }
    }
}